// Code generated by Kitex v0.8.0. DO NOT EDIT.

package echo

import (
	"context"
	"errors"
	client "github.com/cloudwego/kitex/client"
	kitex "github.com/cloudwego/kitex/pkg/serviceinfo"
	streaming "github.com/cloudwego/kitex/pkg/streaming"
	proto "google.golang.org/protobuf/proto"
	api "jsonpb-demo/kitex_gen/api"
)

var errInvalidMessageType = errors.New("invalid message type for service method handler")

var serviceMethods = map[string]kitex.MethodInfo{
	"EchoPB": kitex.NewMethodInfo(
		echoPBHandler,
		newEchoPBArgs,
		newEchoPBResult,
		false,
		kitex.WithStreamingMode(kitex.StreamingUnary),
	),
}

var (
	echoServiceInfo                = NewServiceInfo()
	echoServiceInfoForClient       = NewServiceInfoForClient()
	echoServiceInfoForStreamClient = NewServiceInfoForStreamClient()
)

// for server
func serviceInfo() *kitex.ServiceInfo {
	return echoServiceInfo
}

// for client
func serviceInfoForStreamClient() *kitex.ServiceInfo {
	return echoServiceInfoForStreamClient
}

// for stream client
func serviceInfoForClient() *kitex.ServiceInfo {
	return echoServiceInfoForClient
}

// NewServiceInfo creates a new ServiceInfo containing all methods
func NewServiceInfo() *kitex.ServiceInfo {
	return newServiceInfo(false, true, true)
}

// NewServiceInfo creates a new ServiceInfo containing non-streaming methods
func NewServiceInfoForClient() *kitex.ServiceInfo {
	return newServiceInfo(false, false, true)
}
func NewServiceInfoForStreamClient() *kitex.ServiceInfo {
	return newServiceInfo(true, true, false)
}

func newServiceInfo(hasStreaming bool, keepStreamingMethods bool, keepNonStreamingMethods bool) *kitex.ServiceInfo {
	serviceName := "Echo"
	handlerType := (*api.Echo)(nil)
	methods := map[string]kitex.MethodInfo{}
	for name, m := range serviceMethods {
		if m.IsStreaming() && !keepStreamingMethods {
			continue
		}
		if !m.IsStreaming() && !keepNonStreamingMethods {
			continue
		}
		methods[name] = m
	}
	extra := map[string]interface{}{
		"PackageName": "api",
	}
	if hasStreaming {
		extra["streaming"] = hasStreaming
	}
	svcInfo := &kitex.ServiceInfo{
		ServiceName:     serviceName,
		HandlerType:     handlerType,
		Methods:         methods,
		PayloadCodec:    kitex.Protobuf,
		KiteXGenVersion: "v0.8.0",
		Extra:           extra,
	}
	return svcInfo
}

func echoPBHandler(ctx context.Context, handler interface{}, arg, result interface{}) error {
	switch s := arg.(type) {
	case *streaming.Args:
		st := s.Stream
		req := new(api.Request)
		if err := st.RecvMsg(req); err != nil {
			return err
		}
		resp, err := handler.(api.Echo).EchoPB(ctx, req)
		if err != nil {
			return err
		}
		return st.SendMsg(resp)
	case *EchoPBArgs:
		success, err := handler.(api.Echo).EchoPB(ctx, s.Req)
		if err != nil {
			return err
		}
		realResult := result.(*EchoPBResult)
		realResult.Success = success
		return nil
	default:
		return errInvalidMessageType
	}
}
func newEchoPBArgs() interface{} {
	return &EchoPBArgs{}
}

func newEchoPBResult() interface{} {
	return &EchoPBResult{}
}

type EchoPBArgs struct {
	Req *api.Request
}

func (p *EchoPBArgs) FastRead(buf []byte, _type int8, number int32) (n int, err error) {
	if !p.IsSetReq() {
		p.Req = new(api.Request)
	}
	return p.Req.FastRead(buf, _type, number)
}

func (p *EchoPBArgs) FastWrite(buf []byte) (n int) {
	if !p.IsSetReq() {
		return 0
	}
	return p.Req.FastWrite(buf)
}

func (p *EchoPBArgs) Size() (n int) {
	if !p.IsSetReq() {
		return 0
	}
	return p.Req.Size()
}

func (p *EchoPBArgs) Marshal(out []byte) ([]byte, error) {
	if !p.IsSetReq() {
		return out, nil
	}
	return proto.Marshal(p.Req)
}

func (p *EchoPBArgs) Unmarshal(in []byte) error {
	msg := new(api.Request)
	if err := proto.Unmarshal(in, msg); err != nil {
		return err
	}
	p.Req = msg
	return nil
}

var EchoPBArgs_Req_DEFAULT *api.Request

func (p *EchoPBArgs) GetReq() *api.Request {
	if !p.IsSetReq() {
		return EchoPBArgs_Req_DEFAULT
	}
	return p.Req
}

func (p *EchoPBArgs) IsSetReq() bool {
	return p.Req != nil
}

func (p *EchoPBArgs) GetFirstArgument() interface{} {
	return p.Req
}

type EchoPBResult struct {
	Success *api.Response
}

var EchoPBResult_Success_DEFAULT *api.Response

func (p *EchoPBResult) FastRead(buf []byte, _type int8, number int32) (n int, err error) {
	if !p.IsSetSuccess() {
		p.Success = new(api.Response)
	}
	return p.Success.FastRead(buf, _type, number)
}

func (p *EchoPBResult) FastWrite(buf []byte) (n int) {
	if !p.IsSetSuccess() {
		return 0
	}
	return p.Success.FastWrite(buf)
}

func (p *EchoPBResult) Size() (n int) {
	if !p.IsSetSuccess() {
		return 0
	}
	return p.Success.Size()
}

func (p *EchoPBResult) Marshal(out []byte) ([]byte, error) {
	if !p.IsSetSuccess() {
		return out, nil
	}
	return proto.Marshal(p.Success)
}

func (p *EchoPBResult) Unmarshal(in []byte) error {
	msg := new(api.Response)
	if err := proto.Unmarshal(in, msg); err != nil {
		return err
	}
	p.Success = msg
	return nil
}

func (p *EchoPBResult) GetSuccess() *api.Response {
	if !p.IsSetSuccess() {
		return EchoPBResult_Success_DEFAULT
	}
	return p.Success
}

func (p *EchoPBResult) SetSuccess(x interface{}) {
	p.Success = x.(*api.Response)
}

func (p *EchoPBResult) IsSetSuccess() bool {
	return p.Success != nil
}

func (p *EchoPBResult) GetResult() interface{} {
	return p.Success
}

type kClient struct {
	c client.Client
}

func newServiceClient(c client.Client) *kClient {
	return &kClient{
		c: c,
	}
}

func (p *kClient) EchoPB(ctx context.Context, Req *api.Request) (r *api.Response, err error) {
	var _args EchoPBArgs
	_args.Req = Req
	var _result EchoPBResult
	if err = p.c.Call(ctx, "EchoPB", &_args, &_result); err != nil {
		return
	}
	return _result.GetSuccess(), nil
}
