// Code generated by Kitex v0.9.0. DO NOT EDIT.

package servicea

import (
	"context"
	"errors"
	api "github.com/cloudwego/kitex-examples/thrift_multi_service/kitex_gen/api"
	client "github.com/cloudwego/kitex/client"
	kitex "github.com/cloudwego/kitex/pkg/serviceinfo"
)

var errInvalidMessageType = errors.New("invalid message type for service method handler")

var serviceMethods = map[string]kitex.MethodInfo{
	"echoA": kitex.NewMethodInfo(
		echoAHandler,
		newServiceAEchoAArgs,
		newServiceAEchoAResult,
		false,
		kitex.WithStreamingMode(kitex.StreamingNone),
	),
}

var (
	serviceAServiceInfo                = NewServiceInfo()
	serviceAServiceInfoForClient       = NewServiceInfoForClient()
	serviceAServiceInfoForStreamClient = NewServiceInfoForStreamClient()
)

// for server
func serviceInfo() *kitex.ServiceInfo {
	return serviceAServiceInfo
}

// for client
func serviceInfoForStreamClient() *kitex.ServiceInfo {
	return serviceAServiceInfoForStreamClient
}

// for stream client
func serviceInfoForClient() *kitex.ServiceInfo {
	return serviceAServiceInfoForClient
}

// NewServiceInfo creates a new ServiceInfo containing all methods
func NewServiceInfo() *kitex.ServiceInfo {
	return newServiceInfo(false, true, true)
}

// NewServiceInfo creates a new ServiceInfo containing non-streaming methods
func NewServiceInfoForClient() *kitex.ServiceInfo {
	return newServiceInfo(false, false, true)
}
func NewServiceInfoForStreamClient() *kitex.ServiceInfo {
	return newServiceInfo(true, true, false)
}

func newServiceInfo(hasStreaming bool, keepStreamingMethods bool, keepNonStreamingMethods bool) *kitex.ServiceInfo {
	serviceName := "ServiceA"
	handlerType := (*api.ServiceA)(nil)
	methods := map[string]kitex.MethodInfo{}
	for name, m := range serviceMethods {
		if m.IsStreaming() && !keepStreamingMethods {
			continue
		}
		if !m.IsStreaming() && !keepNonStreamingMethods {
			continue
		}
		methods[name] = m
	}
	extra := map[string]interface{}{
		"PackageName": "api",
	}
	if hasStreaming {
		extra["streaming"] = hasStreaming
	}
	svcInfo := &kitex.ServiceInfo{
		ServiceName:     serviceName,
		HandlerType:     handlerType,
		Methods:         methods,
		PayloadCodec:    kitex.Thrift,
		KiteXGenVersion: "v0.9.0",
		Extra:           extra,
	}
	return svcInfo
}

func echoAHandler(ctx context.Context, handler interface{}, arg, result interface{}) error {
	realArg := arg.(*api.ServiceAEchoAArgs)
	realResult := result.(*api.ServiceAEchoAResult)
	success, err := handler.(api.ServiceA).EchoA(ctx, realArg.Req)
	if err != nil {
		return err
	}
	realResult.Success = success
	return nil
}
func newServiceAEchoAArgs() interface{} {
	return api.NewServiceAEchoAArgs()
}

func newServiceAEchoAResult() interface{} {
	return api.NewServiceAEchoAResult()
}

type kClient struct {
	c client.Client
}

func newServiceClient(c client.Client) *kClient {
	return &kClient{
		c: c,
	}
}

func (p *kClient) EchoA(ctx context.Context, req *api.Request) (r *api.Response, err error) {
	var _args api.ServiceAEchoAArgs
	_args.Req = req
	var _result api.ServiceAEchoAResult
	if err = p.c.Call(ctx, "echoA", &_args, &_result); err != nil {
		return
	}
	return _result.GetSuccess(), nil
}
